using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
namespace IRaCIS.Core.Domain.Models
{
	 ///<summary>
	 /// 一致性核查文件
	 ///</summary>
	 [Table("InspectionFile")]	
	 public class InspectionFile : Entity, IAuditAdd
	 {
		/// <summary>
		/// 文件名称
		/// </summary>
		public string FileName { get; set; }



		/// <summary>
		/// 相对路径
		/// </summary>
		public string RelativePath { get; set; }


		/// <summary>
		/// 创建人
		/// </summary>
		public Guid CreateUserId { get; set; }


		/// <summary>
		/// 创建时间
		/// </summary>
		public DateTime CreateTime { get; set; }

		/// <summary>
		/// 项目ID
		/// </summary>
		public Guid TrialId { get; set; }

		[JsonIgnore]
		/// <summary>
		/// 创建人
		/// </summary>
		[ForeignKey("CreateUserId")]
		public User User { get; set; }


		public UploadScenarios UploadScenarios { get;set; }

    }

	public enum UploadScenarios
	{
		Check=0,

		Site=1,
	}

}	 
